/* --------------------------------------------------------------
          ( 1.2c).
       .

    http://www.imach.uran.ru/cbignum

    Copyright 1999-2010, ..,   PAH.
    All Rights Reserved.

         "public domain",
    ..   ,  
         
          .

        " "
     - ,   . 
           . 
          , ,
            
       .
-------------------------------------------------------------- */
#ifndef _CBIGNUMF_H
#define _CBIGNUMF_H

//================================================
//        .
//================================================
//      _CBIGNUM_ASM              Cbignumf.cpp

#ifndef _CBIGNUMF_INL
#if 1
#define _CBIGNUM_ASM
#endif
#endif//_CBIGNUMF_INL

//================================================
//        .
//================================================
//      _CBIGNUM_HARDWARE_CBR     .
//      _CBIGNUM_HARDWARE_MUL   .
//      _CBIGNUM_HARDWARE_DIV   .

#ifdef  _CBIGNUM_ASM
#include "Cbnl.h"
#ifdef  _CBNL_WASM

#if 1
#define _CBIGNUM_HARDWARE_CBR
#endif

#if 1
#define _CBIGNUM_HARDWARE_MUL
#endif

#endif//_CBNL_WASM
#endif//_CBIGNUM_ASM

#if 0
#define _CBIGNUM_HARDWARE_DIV
#endif

//================================================
//        .
//================================================
//      _CBIGNUM_KARATSUBA_MUL    , 
//                                  _CBNL_KARATSUBA_MIN
//                                .
//
//      _CBIGNUM_BLOCK_MUL        , 
//                                  _CBNL_TAB_HIGH
//                                 (  
//                                L1,   
//                                 ,
//                               ,    
//                               _CBNL_KARATSUBA_MIN ).
//
//      _CBIGNUM_TERNARY_MUL       30% 
//                                   
//                                  (
//                                  
//                               ,   ).
//
//      _CBIGNUM_SHIFTTAB_MUL       
//                              ,     
//                              _CBNL_TAB_MIN    (
//                                 
//                              ,   ).
//
//      _CBIGNUM_SHIFTTAB_DIV       
//                                ,   
//                               _CBNL_TAB_MIN    ,
//                               ,    _CBNL_TAB_MAX
//                              .
//
//      _CBIGNUM_REDUCE_JUMPS     
//                                  .
//                                 .

#if 1
#define _CBIGNUM_KARATSUBA_MUL
#endif

#if 1
#define _CBIGNUM_BLOCK_MUL
#endif

#if 1
#define _CBIGNUM_TERNARY_MUL
#endif

#if 1
#define _CBIGNUM_SHIFTTAB_MUL
#endif

#if 1
#define _CBIGNUM_SHIFTTAB_DIV
#endif

#if 0
#define _CBIGNUM_REDUCE_JUMPS
#endif

//================================================
//        .
//================================================
//      _CBNL_TAB_MIN             ,  
//                                  
//                              
//                                  
//                              ,    
//                                .
//
//      _CBNL_TAB_OPT              
//                                  ,
//                                 ;
//                                  8n - 3.
//
//      _CBNL_TAB_HIGH             
//                                  ,
//                                 .
//
//      _CBNL_TAB_MAX             ,  
//                                  .
//
//      _CBNL_MUL_OPT              
//                                 ,
//                                 ;
//                                  8n - 3.
//
//      _CBNL_MUL_HIGH             
//                                 ,
//                                 .
//
//      _CBNL_KARATSUBA_MIN         
//                                 .
//
//           long   .

#define _CBNL_TAB_MIN   (3)
#define _CBNL_TAB_OPT   (((sizeof(size_t))<=2? 120: 7680)/\
                         (sizeof (long) * sizeof (long)) - 3)
#define _CBNL_TAB_HIGH  (_CBNL_TAB_OPT + _CBNL_TAB_OPT / 2)
#define _CBNL_TAB_MAX   ((EXSIZE_T_MAX & (size_t)0xFFFFFFFFUL)/\
                         (256 * sizeof (long) * sizeof (long)))

#ifndef _CBIGNUM_HARDWARE_MUL
#define _CBNL_KARATSUBA_MIN     (100)
#else //_CBIGNUM_HARDWARE_MUL
#define _CBNL_KARATSUBA_MIN     (50)
#define _CBNL_MUL_OPT   (7680 / sizeof (long) - 3)
#define _CBNL_MUL_HIGH  (_CBNL_MUL_OPT + _CBNL_MUL_OPT / 2)
#endif//_CBIGNUM_HARDWARE_MUL

#endif//_CBIGNUMF_H
